PointOfSalesWebApp/Controllers/ProductManagerController.cs
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.IO;
using PointOfSalesWebApp.Interfaces;
using PointOfSalesWebApp.Models;
using PointOfSalesWebApp.ViewModels;

namespace PointOfSalesWebApp.Controllers
{
    public class ProductManagerController : Controller
    {
        IRepository<Product> context;
        IRepository<ProductCategory> productCategories;
        IRepository<ProductCompany> productCompanies;
        //public ApplicationDbContext dbContext;

        public ProductManagerController(IRepository<Product> productContext, IRepository<ProductCategory> productCategoryContext, IRepository<ProductCompany> productCompanyContext) {
            context = productContext;
            productCategories = productCategoryContext;
            productCompanies = productCompanyContext;
            //dbContext = new ApplicationDbContext();
        }
        [Authorize(Roles = "Admin,Employee")]

        public ActionResult Index()
        {
            
            List<Product> products = context.Collection().Include(x=>x.Category).Include(x=>x.ProductCompany).ToList();
            return View(products);
        }

        [HttpGet]
        [Authorize(Roles = "Admin,Employee")]

        public ActionResult Create() {
            ProductView viewModel = new ProductView();

            viewModel.Product = new Product();
            viewModel.Categories = productCategories.Collection().ToList();
            viewModel.Companies = productCompanies.Collection().ToList();
            //Product product = new Product();

            //ViewBag.Categories = dbContext.ProductCategories.ToList();
            //ViewBag.Companies = dbContext.ProductCompanies.ToList();
            return View(viewModel);
        }

        [HttpPost]
        public ActionResult Create(Product product, HttpPostedFileBase file) {
            if (!ModelState.IsValid)
            {
                return View(product);
            }
            else {

                if (file != null) {
                    product.Image = product.Id + Path.GetExtension(file.FileName);
                    file.SaveAs(Server.MapPath("//Content//ProductImages//") + product.Image);
                }

                context.Insert(product);
                context.Commit();

                return RedirectToAction("Index");
            }

        }
        [Authorize(Roles = "Admin")]
        public ActionResult Edit(string Id) {

            ViewBag.Categories = productCategories.Collection().ToList();
            ViewBag.Companies = productCompanies.Collection().ToList();

            Product product = context.Find(Id);
            if (product == null)
            {
                return HttpNotFound();
            }
            else {
                //ProductView viewModel = new ProductView();
                //viewModel.Product = product;
                //viewModel.Categories = productCategories.Collection().ToList();
                //viewModel.Companies = productCompanies.Collection().ToList();
                


                return View(product);
            }
        }

        [HttpPost]
        public ActionResult Edit(Product product, string Id, HttpPostedFileBase file)
        {
            ViewBag.Categories = productCategories.Collection().ToList();
            ViewBag.Companies = productCompanies.Collection().ToList();
            Product productToEdit = context.Find(Id);

            if (productToEdit == null)
            {
                return HttpNotFound();
            }
            else
            {
                if (!ModelState.IsValid) {
                    return View(product);
                }

                if (file != null) {
                    productToEdit.Image = product.Id + Path.GetExtension(file.FileName);
                    file.SaveAs(Server.MapPath("//Content//ProductImages//") + productToEdit.Image);
                }
                productToEdit.ProductCompanyId = product.ProductCompanyId;
                productToEdit.ProductCategoryId = product.ProductCategoryId;
                productToEdit.Description = product.Description;
                productToEdit.Name = product.Name;
                productToEdit.Price = product.Price;
                productToEdit.ProductCode = product.ProductCode;
                productToEdit.WholeSalePrice = product.WholeSalePrice;
                


                context.Commit();

                return RedirectToAction("Index");
            }
        }
        [Authorize(Roles = "Admin")]

        public ActionResult Delete(string Id)
        {
            Product productToDelete = context.Find(Id);

            if (productToDelete == null)
            {
                return HttpNotFound();
            }
            else
            {
                return View(productToDelete);
            }
        }

        [HttpPost]
        [ActionName("Delete")]
        public ActionResult ConfirmDelete(string Id) {
            Product productToDelete = context.Find(Id);

            if (productToDelete == null)
            {
                return HttpNotFound();
            }
            else
            {
                context.Delete(Id);
                context.Commit();
                return RedirectToAction("Index");
            }
        }
    }
}

PointOfSalesWebApp/Views/ProductManager/Create.cshtml
@model PointOfSalesWebApp.ViewModels.ProductView

@{
    ViewBag.Title = "Create";
}
<style>
    label {
        color: azure;
        font-weight: bold;
    }
</style>


@using (Html.BeginForm("Create", "ProductManager", FormMethod.Post, new { encType = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })

    <div style="background-color:black;padding-left: ; border: 0pt whitesmoke groove; border-radius: 5pt; margin-bottom:3% ;">

        <button type="button" class="btn btn-lg btn-block" style="margin-top: 3%; margin-bottom: 3%;background-color:darkslategrey;color:azure;font-weight:bold">Create New Product</button>

        <div class="col-md-12">
            <h4 class="btn btn-info" style="padding-left:35px;padding-right:35px;font-weight:bolder;font-size:large">Create New Product</h4>

        </div>
        <div class="row" style="">


            <div class="col-md-6">
                <div class="form-group col-md-12">
                    @Html.LabelFor(model => model.Product.Name, htmlAttributes: new { @class = "control-label" })

                    @Html.EditorFor(model => model.Product.Name, new { htmlAttributes = new { @class = "form-control col-md-12" } })
                    @Html.ValidationMessageFor(model => model.Product.Name, "", new { @class = "text-danger" })

                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group col-md-12">
                    @Html.LabelFor(model => model.Product.Description, htmlAttributes: new { @class = "control-label" })

                    @Html.EditorFor(model => model.Product.Description, new { htmlAttributes = new { @class = "form-control col-md-12" } })
                    @Html.ValidationMessageFor(model => model.Product.Description, "", new { @class = "text-danger" })

                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group col-md-12">
                    @Html.LabelFor(model => model.Product.ProductCode, htmlAttributes: new { @class = "control-label" })

                    @Html.EditorFor(model => model.Product.ProductCode, new { htmlAttributes = new { @class = "form-control col-md-12" } })
                    @Html.ValidationMessageFor(model => model.Product.ProductCode, "", new { @class = "text-danger" })

                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group col-md-12">
                    @Html.LabelFor(model => model.Product.Price, htmlAttributes: new { @class = "control-label" })

                    @Html.EditorFor(model => model.Product.Price, new { htmlAttributes = new { @class = "form-control col-md-12" } })
                    @Html.ValidationMessageFor(model => model.Product.Price, "", new { @class = "text-danger" })

                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group col-md-12">
                    @Html.LabelFor(model => model.Product.WholeSalePrice, htmlAttributes: new { @class = "control-label" })

                    @Html.EditorFor(model => model.Product.WholeSalePrice, new { htmlAttributes = new { @class = "form-control col-md-12" } })
                    @Html.ValidationMessageFor(model => model.Product.WholeSalePrice, "", new { @class = "text-danger" })

                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group col-md-12">
                    @Html.LabelFor(model => model.Product.ProductCategoryId, htmlAttributes: new { @class = "control-label" })

                    @*@Html.DropDownListFor(model => model.Product.ProductCategoryId, new SelectList(Model.Categories, "Id", "Category"), "--select category--", new { htmlAttributes = new { @class = "form-control col-md-12" }, @style = "font-weight:bold;color:black;background-color: white;" })*@
                    @Html.DropDownListFor(model => model.Product.ProductCategoryId, new SelectList(Model.Categories, "Id", "Category"), "-- Select Category --", new { @style = "font-weight:bold;color:black;background-color: white;", @class = "form-control col-md-12" })

                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group col-md-12">
                    @Html.LabelFor(model => model.Product.ProductCompanyId, htmlAttributes: new { @class = "control-label" })

                    @*@Html.DropDownListFor(model => model.Product.ProductCompanyId, new SelectList(Model.Companies, "Id", "Company"), "--select company--", new { htmlAttributes = new { @class = "", @style = "font-weight:bold;color:black;background-color: white;" } })*@
                    @Html.DropDownListFor(model=>model.Product.ProductCompanyId, new SelectList(Model.Companies, "Id", "Company"), "-- Select Category --", new { @style = "font-weight:bold;color:black;background-color: white;", @class = "form-control col-md-12" })

                </div>
            </div>

            <div class="col-md-6">
                <div class="form-group col-md-12">
                    @Html.LabelFor(model => model.Product.Image, htmlAttributes: new { @class = "control-label" })

                    <input type="file" id="file" name="file" class="form-control col-md-12" />

                </div>
            </div>
            <div class="col-md-12">
                <div class="form-group col-md-4">
                    <input class="btn btn-info col-md-4" type="submit" value="Create" />
                </div>
            </div>
        </div>

    </div>

}

<div style="margin-left:5px">
    @Html.ActionLink("Back to List", "Index", null, new { @class = "btn btn-success" })
</div>

PointOfSalesWebApp/Views/ProductManager/Delete.cshtml
@model PointOfSalesWebApp.Models.Product

@{
    ViewBag.Title = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Product</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Name)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Name)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Description)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Description)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Price)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Price)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Category)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Category)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Image)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Image)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input class="btn btn-primary" type="submit" value="Delete" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>

PointOfSalesWebApp/Views/ProductManager/Edit.cshtml
@model PointOfSalesWebApp.Models.Product

@{
    ViewBag.Title = "Edit";
}

<h2>Edit</h2>

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()
    
<div class="form-horizontal">
    <h4>Product</h4>
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    @Html.HiddenFor(model => model.Id)
    <div class="col-md-2">
        <img class="img-responsive" src="~/Content/ProductImages/@Model.Image" />
    </div>
    <div class="form-group">
        @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.ProductCode, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.ProductCode, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.ProductCode, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Price, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Price, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Price, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.WholeSalePrice, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.WholeSalePrice, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.WholeSalePrice, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Quantity, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Quantity, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Quantity, "", new { @class = "text-danger" })
        </div>
    </div>

    @*<div class="form-group">
            @Html.LabelFor(model => model.ProductCategoryId, "ProductCategoryId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("ProductCategoryId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.ProductCategoryId, "", new { @class = "text-danger" })
            </div>
        </div>*@

    <div class="form-group">
        @Html.LabelFor(model => model.ProductCategoryId, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownListFor(model => model.ProductCategoryId, new SelectList(ViewBag.Categories, "Id", "Category"), new { htmlAttributes = new { @class = "form-control" } })
        </div>
    </div>
    <div class="form-group">
        @Html.LabelFor(model => model.ProductCompanyId, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownListFor(model => model.ProductCompanyId, new SelectList(ViewBag.Companies, "Id", "Company"), new { htmlAttributes = new { @class = "form-control" } })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Image, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Image, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Image, "", new { @class = "text-danger" })
        </div>
    </div>

    @*<div class="form-group">
            @Html.LabelFor(model => model.CreatedAt, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.CreatedAt, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.CreatedAt, "", new { @class = "text-danger" })
            </div>
        </div>*@

    @*<div class="form-group">
            @Html.LabelFor(model => model.Status, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Status, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Status, "", new { @class = "text-danger" })
            </div>
        </div>*@

    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Save" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

PointOfSalesWebApp/Views/ProductManager/Index.cshtml
@model IEnumerable<PointOfSalesWebApp.Models.Product>

@{
    ViewBag.Title = "Index";
}

<button type="button" class="btn btn-lg btn-block" style="margin-top: 3%; margin-bottom: 3%;background-color:darkslategrey;color:azure;font-weight:bold">Product Index View</button>

<p>
    @Html.ActionLink("Create New Product", "Create", null, new { @class = "btn btn-info" })
</p>
<table class="table table-dark">
    <tr class="text-info">
        <th>
            @Html.DisplayNameFor(model => model.Image)

        </th>
        <th>
            @Html.DisplayNameFor(model => model.Name)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Description)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Price)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Category)
        </th>
        <th>
            Brand
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Quantity)
        </th>
        <th></th>
    </tr>

    @foreach (var item in Model)
    {
        <tr>
            <td>
                <img class="img-thumbnail" style="height:100px;width:100px" src="~/Content/ProductImages/@item.Image" />
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Name)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Description)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Price)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Category.Category)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.ProductCompany.Company)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Quantity)
            </td>
            <td>
                @Html.ActionLink("Edit", "Edit", new { id = item.Id }) |
                @Html.ActionLink("Delete", "Delete", new { id = item.Id })
            </td>
        </tr>
    }

</table>